Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 8143)
@@ -1299,10 +1274,8 @@
       INTEGER  ::   ji ,jj              ! dummy loop indices
       REAL(wp) ::   zxr2, zyr2, zcmax   ! local scalar
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zcu
+      REAL(wp), DIMENSION(jpi,jpj) ::   zcu
       !!----------------------------------------------------------------------
       !
       ! Max courant number for ext. grav. waves
-      !
-      CALL wrk_alloc( jpi,jpj,   zcu )
       !
       DO jj = 1, jpj
@@ -1371,6 +1344,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj,   zcu )
-      !
    END SUBROUTINE dyn_spg_ts_init
 
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 8143)
@@ -9,4 +9,5 @@
    !!            3.3  !  2010-04  (M. Leclair, G. Madec)  Forcing averaged over 2 time steps
    !!            3.4  !  2012-01  (H. Liu) Semi-implicit bottom friction
+   !!            4.0  !  2017-05  (G. Madec)  drag coef. defined at t-point (zdfdrg.F90)
    !!----------------------------------------------------------------------
 
@@ -22,13 +23,8 @@
    USE dynadv   , ONLY: ln_dynadv_vec ! Momentum advection form
    USE zdf_oce        ! ocean vertical physics
-!!gm new
    USE zdfdrg         ! vertical physics: top/bottom drag coef.
-!!gm old
-   USE zdfbfr         ! Bottom friction setup
-!!gm
    !
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory Allocation
    USE timing         ! Timing
 
@@ -65,5 +61,5 @@
       !!      with the following surface/top/bottom boundary condition:
       !!      surface: wind stress input (averaged over kt-1/2 & kt+1/2)
-      !!      top & bottom : top stress (iceshelf-ocean) & bottom stress (cf zdfbfr.F)
+      !!      top & bottom : top stress (iceshelf-ocean) & bottom stress (cf zdfdrg.F90)
       !!
       !! ** Action :   (ua,va) after velocity 
@@ -76,10 +72,8 @@
       REAL(wp) ::   zzwi, ze3ua   ! local scalars
       REAL(wp) ::   zzws, ze3va   !   -      -
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwi, zwd, zws
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zwi, zwd, zws
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('dyn_zdf_imp')
-      !
-      CALL wrk_alloc( jpi,jpj,jpk, zwi, zwd, zws ) 
       !
       IF( kt == nit000 ) THEN
@@ -115,16 +109,11 @@
       ! column vector of the tri-diagonal matrix equation
       !
-      IF( ln_bfrimp ) THEN
+      IF( ln_drgimp ) THEN
          DO jj = 2, jpjm1
             DO ji = 2, jpim1
                ikbu = mbku(ji,jj)       ! ocean bottom level at u- and v-points 
                ikbv = mbkv(ji,jj)       ! (deepest ocean u- and v-points)
-!!gm old
-               avmu(ji,jj,ikbu+1) = -bfrua(ji,jj) * e3uw_n(ji,jj,ikbu+1)
-               avmv(ji,jj,ikbv+1) = -bfrva(ji,jj) * e3vw_n(ji,jj,ikbv+1)
-!!gm new
-!               avmu(ji,jj,ikbu+1) = -0.5*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * e3uw_n(ji,jj,ikbu+1)
-!               avmv(ji,jj,ikbv+1) = -0.5*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * e3vw_n(ji,jj,ikbv+1)
-!!gm
+               avmu(ji,jj,ikbu+1) = -0.5*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * e3uw_n(ji,jj,ikbu+1)
+               avmv(ji,jj,ikbv+1) = -0.5*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * e3vw_n(ji,jj,ikbv+1)
             END DO
          END DO
@@ -134,12 +123,7 @@
                   ikbu = miku(ji,jj)       ! ocean top level at u- and v-points 
                   ikbv = mikv(ji,jj)       ! (first wet ocean u- and v-points)
-!!gm old
-                  IF( ikbu >= 2 )   avmu(ji,jj,ikbu) = -tfrua(ji,jj) * e3uw_n(ji,jj,ikbu)
-                  IF( ikbv >= 2 )   avmv(ji,jj,ikbv) = -tfrva(ji,jj) * e3vw_n(ji,jj,ikbv)
-!!gm new
                   ! top Cd is masked (=0 outside cavities) no need of test on mik>=2
-!                  avmu(ji,jj,ikbu) = -0.5*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * e3uw_n(ji,jj,ikbu)
-!                  avmv(ji,jj,ikbv) = -0.5*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * e3vw_n(ji,jj,ikbv)
-!!gm
+                  avmu(ji,jj,ikbu) = -0.5*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * e3uw_n(ji,jj,ikbu)
+                  avmv(ji,jj,ikbv) = -0.5*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * e3vw_n(ji,jj,ikbv)
                END DO
             END DO
@@ -152,5 +136,5 @@
       !            not lead to the effective stress seen over the whole barotropic loop. 
       ! G. Madec : in linear free surface, e3u_a = e3u_n = e3u_0, so systematic use of e3u_a
-      IF( ln_bfrimp .AND. ln_dynspg_ts ) THEN
+      IF( ln_drgimp .AND. ln_dynspg_ts ) THEN
          DO jk = 1, jpkm1        ! remove barotropic velocities
             ua(:,:,jk) = ( ua(:,:,jk) - ua_b(:,:) ) * umask(:,:,jk)
@@ -163,11 +147,6 @@
                ze3ua =  ( 1._wp - r_vvl ) * e3u_n(ji,jj,ikbu) + r_vvl * e3u_a(ji,jj,ikbu)
                ze3va =  ( 1._wp - r_vvl ) * e3v_n(ji,jj,ikbv) + r_vvl * e3v_a(ji,jj,ikbv)
-!!gm old
-               ua(ji,jj,ikbu) = ua(ji,jj,ikbu) + p2dt * bfrua(ji,jj) * ua_b(ji,jj) / ze3ua
-               va(ji,jj,ikbv) = va(ji,jj,ikbv) + p2dt * bfrva(ji,jj) * va_b(ji,jj) / ze3va
-!!gm new
-!               ua(ji,jj,ikbu) = ua(ji,jj,ikbu) + p2dt * 0.5*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * ua_b(ji,jj) / ze3ua
-!               va(ji,jj,ikbv) = va(ji,jj,ikbv) + p2dt * 0.5*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * va_b(ji,jj) / ze3va
-!!gm
+               ua(ji,jj,ikbu) = ua(ji,jj,ikbu) + p2dt * 0.5*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * ua_b(ji,jj) / ze3ua
+               va(ji,jj,ikbv) = va(ji,jj,ikbv) + p2dt * 0.5*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * va_b(ji,jj) / ze3va
             END DO
          END DO
@@ -179,11 +158,6 @@
                   ze3ua =  ( 1._wp - r_vvl ) * e3u_n(ji,jj,ikbu) + r_vvl * e3u_a(ji,jj,ikbu)
                   ze3va =  ( 1._wp - r_vvl ) * e3v_n(ji,jj,ikbv) + r_vvl * e3v_a(ji,jj,ikbv)
-!!gm old
-                  ua(ji,jj,ikbu) = ua(ji,jj,ikbu) + p2dt * tfrua(ji,jj) * ua_b(ji,jj) / ze3ua
-                  va(ji,jj,ikbv) = va(ji,jj,ikbv) + p2dt * tfrva(ji,jj) * va_b(ji,jj) / ze3va
-!!gm new
                   ua(ji,jj,ikbu) = ua(ji,jj,ikbu) + p2dt * 0.5*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * ua_b(ji,jj) / ze3ua
                   va(ji,jj,ikbv) = va(ji,jj,ikbv) + p2dt * 0.5*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * va_b(ji,jj) / ze3va
-!!gm
                END DO
             END DO
@@ -342,30 +316,4 @@
          END DO
       END DO
-      
-      ! J. Chanut: Lines below are useless ?
-      !! restore bottom layer avmu(v) 
-      !!gm  I almost sure it is !!!!
-      IF( ln_bfrimp ) THEN
-        DO jj = 2, jpjm1
-           DO ji = 2, jpim1
-              ikbu = mbku(ji,jj)         ! ocean bottom level at u- and v-points 
-              ikbv = mbkv(ji,jj)         ! (deepest ocean u- and v-points)
-              avmu(ji,jj,ikbu+1) = 0._wp
-              avmv(ji,jj,ikbv+1) = 0._wp
-           END DO
-        END DO
-        IF (ln_isfcav) THEN
-           DO jj = 2, jpjm1
-              DO ji = 2, jpim1
-                 ikbu = miku(ji,jj)         ! ocean top level at u- and v-points 
-                 ikbv = mikv(ji,jj)         ! (first wet ocean u- and v-points)
-                 IF( ikbu > 1 )   avmu(ji,jj,ikbu) = 0._wp
-                 IF( ikbv > 1 )   avmv(ji,jj,ikbv) = 0._wp
-              END DO
-           END DO
-        ENDIF
-      ENDIF
-      !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zwi, zwd, zws) 
       !
       IF( nn_timing == 1 )   CALL timing_stop('dyn_zdf_imp')
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90	(revision 8143)
@@ -5,26 +5,26 @@
    !!                   shelf
    !!======================================================================
-   !! History :  3.2   !  2011-02  (C.Harris  ) Original code isf cav
-   !!            X.X   !  2006-02  (C. Wang   ) Original code bg03
-   !!            3.4   !  2013-03  (P. Mathiot) Merging + parametrization
+   !! History :  3.2  !  2011-02  (C.Harris  ) Original code isf cav
+   !!            X.X  !  2006-02  (C. Wang   ) Original code bg03
+   !!            3.4  !  2013-03  (P. Mathiot) Merging + parametrization
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   sbc_isf        : update sbc under ice shelf
+   !!   sbc_isf       : update sbc under ice shelf
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE phycst          ! physical constants
-   USE eosbn2          ! equation of state
-   USE sbc_oce         ! surface boundary condition: ocean fields
-   USE zdfbfr          !
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE phycst         ! physical constants
+   USE eosbn2         ! equation of state
+   USE sbc_oce        ! surface boundary condition: ocean fields
+   USE zdfdrg         ! vertical physics: top/bottom drag coef.
    !
-   USE in_out_manager  ! I/O manager
-   USE iom             ! I/O manager library
-   USE fldread         ! read input field at current time step
-   USE lbclnk          !
-   USE wrk_nemo        ! Memory allocation
-   USE timing          ! Timing
-   USE lib_fortran     ! glob_sum
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
+   USE fldread        ! read input field at current time step
+   USE lbclnk         !
+   USE wrk_nemo       ! Memory allocation
+   USE timing         ! Timing
+   USE lib_fortran    ! glob_sum
 
    IMPLICIT NONE
@@ -77,5 +77,5 @@
 CONTAINS
  
-  SUBROUTINE sbc_isf(kt)
+  SUBROUTINE sbc_isf( kt )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE sbc_isf  ***
@@ -94,5 +94,5 @@
       INTEGER               :: ji, jj, jk           ! loop index
       INTEGER               :: ikt, ikb             ! loop index
-      REAL(wp), DIMENSION (:,:), POINTER :: zt_frz, zdep ! freezing temperature (zt_frz) at depth (zdep) 
+      REAL(wp), DIMENSION(jpi,jpj) ::   zt_frz, zdep   ! freezing temperature (zt_frz) at depth (zdep) 
       REAL(wp), DIMENSION(:,:,:), POINTER :: zfwfisf3d, zqhcisf3d, zqlatisf3d
       REAL(wp), DIMENSION(:,:  ), POINTER :: zqhcisf2d
@@ -100,6 +100,4 @@
       !
       IF( MOD( kt-1, nn_fsbc) == 0 ) THEN
-         ! allocation
-         CALL wrk_alloc( jpi,jpj, zt_frz, zdep  )
 
          ! compute salt and heat flux
@@ -204,6 +202,4 @@
             CALL wrk_dealloc( jpi,jpj,     zqhcisf2d                        )
           END IF
-          ! deallocation
-          CALL wrk_dealloc( jpi,jpj, zt_frz, zdep  )
           !
         END IF
@@ -254,4 +250,5 @@
   END FUNCTION
 
+
   SUBROUTINE sbc_isf_init
       !!---------------------------------------------------------------------
@@ -289,8 +286,6 @@
 
       IF ( lwp ) WRITE(numout,*)
-      IF ( lwp ) WRITE(numout,*) 'sbc_isf: heat flux of the ice shelf'
-      IF ( lwp ) WRITE(numout,*) '~~~~~~~~~'
-      IF ( lwp ) WRITE(numout,*) 'sbcisf :' 
-      IF ( lwp ) WRITE(numout,*) '~~~~~~~~'
+      IF ( lwp ) WRITE(numout,*) 'sbc_isf_init : heat flux of the ice shelf'
+      IF ( lwp ) WRITE(numout,*) '~~~~~~~~~~~'
       IF ( lwp ) WRITE(numout,*) '        nn_isf      = ', nn_isf
       IF ( lwp ) WRITE(numout,*) '        nn_isfblk   = ', nn_isfblk
@@ -299,5 +294,5 @@
       IF ( lwp ) WRITE(numout,*) '        rn_gammat0  = ', rn_gammat0  
       IF ( lwp ) WRITE(numout,*) '        rn_gammas0  = ', rn_gammas0  
-      IF ( lwp ) WRITE(numout,*) '        rn_tfri2    = ', rn_tfri2 
+      IF ( lwp ) WRITE(numout,*) '        rn_Cd0      = ', r_Cdmin_top 
       !
       ! Allocate public variable
@@ -305,6 +300,6 @@
       !
       ! initialisation
-      qisf(:,:)        = 0._wp  ; fwfisf  (:,:) = 0._wp
-      risf_tsc(:,:,:)  = 0._wp  ; fwfisf_b(:,:) = 0._wp
+      qisf    (:,:)    = 0._wp   ;   fwfisf  (:,:) = 0._wp
+      risf_tsc(:,:,:)  = 0._wp   ;   fwfisf_b(:,:) = 0._wp
       !
       ! define isf tbl tickness, top and bottom indice
@@ -312,5 +307,5 @@
       CASE ( 1 ) 
          rhisf_tbl(:,:) = rn_hisf_tbl
-         misfkt(:,:)    = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
+         misfkt   (:,:) = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
 
       CASE ( 2 , 3 )
@@ -346,4 +341,5 @@
             DO jj = 1, jpj
                 ik = 2
+!!gm potential bug: use gdepw_0 not _n
                 DO WHILE ( ik <= mbkt(ji,jj) .AND. gdepw_n(ji,jj,ik) < rzisf_tbl(ji,jj) ) ;  ik = ik + 1 ;  END DO
                 misfkt(ji,jj) = ik-1
@@ -354,5 +350,5 @@
          ! as in nn_isf == 1
          rhisf_tbl(:,:) = rn_hisf_tbl
-         misfkt(:,:)    = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
+         misfkt   (:,:) = mikt(:,:)         ! same indice for bg03 et cav => used in isfdiv
          
          ! load variable used in fldread (use for temporal interpolation of isf fwf forcing)
@@ -377,5 +373,5 @@
             ! determine the deepest level influenced by the boundary layer
             DO jk = ikt+1, mbkt(ji,jj)
-               IF ( (SUM(e3t_n(ji,jj,ikt:jk-1)) < rhisf_tbl(ji,jj)) .AND. (tmask(ji,jj,jk) == 1) ) ikb = jk
+               IF( (SUM(e3t_n(ji,jj,ikt:jk-1)) < rhisf_tbl(ji,jj)) .AND. (tmask(ji,jj,jk) == 1) )   ikb = jk
             END DO
             rhisf_tbl(ji,jj) = MIN(rhisf_tbl(ji,jj), SUM(e3t_n(ji,jj,ikt:ikb))) ! limit the tbl to water thickness.
@@ -390,4 +386,5 @@
   END SUBROUTINE sbc_isf_init
 
+
   SUBROUTINE sbc_isf_bg03(kt)
       !!---------------------------------------------------------------------
@@ -402,6 +399,5 @@
       !!         interaction for climate models", Ocean Modelling 5(2003) 157-170.
       !!         (hereafter BG)
-      !! History :
-      !!         06-02  (C. Wang) Original code
+      !! History :  06-02  (C. Wang) Original code
       !!----------------------------------------------------------------------
       INTEGER, INTENT ( in ) :: kt
@@ -415,5 +411,5 @@
       !!----------------------------------------------------------------------
 
-      IF ( nn_timing == 1 ) CALL timing_start('sbc_isf_bg03')
+      IF( nn_timing == 1 )   CALL timing_start('sbc_isf_bg03')
       !
       DO ji = 1, jpi
@@ -441,12 +437,13 @@
                !add to salinity trend
             ELSE
-               qisf(ji,jj) = 0._wp ; fwfisf(ji,jj) = 0._wp
+               qisf(ji,jj) = 0._wp   ;   fwfisf(ji,jj) = 0._wp
             END IF
          END DO
       END DO
       !
-      IF( nn_timing == 1 )  CALL timing_stop('sbc_isf_bg03')
+      IF( nn_timing == 1 )   CALL timing_stop('sbc_isf_bg03')
       !
   END SUBROUTINE sbc_isf_bg03
+
 
   SUBROUTINE sbc_isf_cav( kt )
@@ -463,8 +460,9 @@
       !!                emp, emps  : update freshwater flux below ice shelf
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in)          ::   kt         ! ocean time step
+      INTEGER, INTENT(in) ::   kt   ! ocean time step
       !
       INTEGER  ::   ji, jj     ! dummy loop indices
       INTEGER  ::   nit
+      LOGICAL  ::   lit
       REAL(wp) ::   zlamb1, zlamb2, zlamb3
       REAL(wp) ::   zeps1,zeps2,zeps3,zeps4,zeps6,zeps7
@@ -472,8 +470,7 @@
       REAL(wp) ::   zeps = 1.e-20_wp        
       REAL(wp) ::   zerr
-      REAL(wp), DIMENSION(:,:), POINTER ::   zfrz
-      REAL(wp), DIMENSION(:,:), POINTER ::   zgammat, zgammas 
-      REAL(wp), DIMENSION(:,:), POINTER ::   zfwflx, zhtflx, zhtflx_b
-      LOGICAL  ::   lit
+      REAL(wp), DIMENSION(jpi,jpj) ::   zfrz
+      REAL(wp), DIMENSION(jpi,jpj) ::   zgammat, zgammas 
+      REAL(wp), DIMENSION(jpi,jpj) ::   zfwflx, zhtflx, zhtflx_b
       !!---------------------------------------------------------------------
       ! coeficient for linearisation of potential tfreez
@@ -484,7 +481,4 @@
       IF( nn_timing == 1 )  CALL timing_start('sbc_isf_cav')
       !
-      CALL wrk_alloc( jpi,jpj, zfrz  , zgammat, zgammas  )
-      CALL wrk_alloc( jpi,jpj, zfwflx, zhtflx , zhtflx_b )
-
       ! initialisation
       zgammat(:,:) = rn_gammat0 ; zgammas (:,:) = rn_gammas0
@@ -578,7 +572,4 @@
       CALL iom_put('isfgammas', zgammas)
       ! 
-      CALL wrk_dealloc( jpi,jpj, zfrz  , zgammat, zgammas  )
-      CALL wrk_dealloc( jpi,jpj, zfwflx, zhtflx , zhtflx_b )
-      !
       IF( nn_timing == 1 )  CALL timing_stop('sbc_isf_cav')
       !
@@ -600,5 +591,4 @@
       INTEGER  :: ikt                        
       INTEGER  :: ji, jj                     ! loop index
-      REAL(wp), DIMENSION(:,:), POINTER :: zustar           ! U, V at T point and friction velocity
       REAL(wp) :: zdku, zdkv                 ! U, V shear 
       REAL(wp) :: zPr, zSc, zRc              ! Prandtl, Scmidth and Richardson number 
@@ -614,6 +604,6 @@
       REAL(wp), PARAMETER :: znu   = 1.95e-6_wp ! kinamatic viscosity of sea water (m2.s-1)
       REAL(wp), DIMENSION(2) :: zts, zab
+      REAL(wp), DIMENSION(jpi,jpj) :: zustar   ! U, V at T point and friction velocity
       !!---------------------------------------------------------------------
-      CALL wrk_alloc( jpi,jpj, zustar )
       !
       SELECT CASE ( nn_gammablk )
@@ -626,7 +616,9 @@
          !! Jenkins et al., 2010, JPO, p2298-2312
          !! Adopted by Asay-Davis et al. (2015)
-
-         !! compute ustar (eq. 24)
-         zustar(:,:) = SQRT( rn_tfri2 * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + rn_tfeb2) )
+!!gm  I don't understand the u* expression in those papers... (see for example zdfglf module)
+!!    for me ustar= Cd0 * |U|  not  (Cd0)^1/2 * |U| ....  which is what you can find in Jenkins et al.
+
+         !! compute ustar (eq. 24)           !! NB: here r_Cdmin_top = rn_Cd0 read in namdrg_top namelist)
+         zustar(:,:) = SQRT( r_Cdmin_top * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + r_ke0_top) )
 
          !! Compute gammats
@@ -638,5 +630,5 @@
          !! as MOL depends of flux and flux depends of MOL, best will be iteration (TO DO)
          !! compute ustar
-         zustar(:,:) = SQRT( rn_tfri2 * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + rn_tfeb2) )
+         zustar(:,:) = SQRT( r_Cdmin_top * (utbl(:,:) * utbl(:,:) + vtbl(:,:) * vtbl(:,:) + r_ke0_top) )
 
          !! compute Pr and Sc number (can be improved)
@@ -649,13 +641,15 @@
 
          !! compute gamma
-         DO ji=2,jpi
-            DO jj=2,jpj
+         DO ji = 2, jpi
+            DO jj = 2, jpj
                ikt = mikt(ji,jj)
 
-               IF (zustar(ji,jj) == 0._wp) THEN           ! only for kt = 1 I think
+               IF( zustar(ji,jj) == 0._wp ) THEN           ! only for kt = 1 I think
                   pgt = rn_gammat0
                   pgs = rn_gammas0
                ELSE
                   !! compute Rc number (as done in zdfric.F90)
+!!gm better to do it like in the new zdfric.F90   i.e. avm weighted Ri computation
+!!gm moreover, use Max(rn2,0) to take care of static instabilities....
                   zcoef = 0.5_wp / e3w_n(ji,jj,ikt)
                   !                                            ! shear of horizontal velocity
@@ -703,8 +697,8 @@
          CALL lbc_lnk(pgs(:,:),'T',1.)
       END SELECT
-      CALL wrk_dealloc( jpi,jpj, zustar )
       !
    END SUBROUTINE sbc_isf_gammats
 
+
    SUBROUTINE sbc_isf_tbl( pvarin, pvarout, cd_ptin )
       !!----------------------------------------------------------------------
@@ -714,13 +708,12 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:,:), INTENT( in  ) :: pvarin
-      REAL(wp), DIMENSION(:,:)  , INTENT( out ) :: pvarout
-      CHARACTER(len=1),           INTENT( in  ) :: cd_ptin ! point of variable in/out
-      !
-      REAL(wp) :: ze3, zhk
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) :: pvarin
+      REAL(wp), DIMENSION(:,:)  , INTENT(  out) :: pvarout
+      CHARACTER(len=1),           INTENT(in   ) :: cd_ptin ! point of variable in/out
+      !
+      INTEGER ::   ji, jj, jk                ! loop index
+      INTEGER ::   ikt, ikb                    ! top and bottom index of the tbl
+      REAL(wp) ::   ze3, zhk
       REAL(wp), DIMENSION(:,:), POINTER :: zhisf_tbl ! thickness of the tbl
-
-      INTEGER :: ji, jj, jk                  ! loop index
-      INTEGER :: ikt, ikb                    ! top and bottom index of the tbl
       !!----------------------------------------------------------------------
       ! allocation
@@ -736,5 +729,5 @@
                ikt = miku(ji,jj) ; ikb = miku(ji,jj)
                ! thickness of boundary layer at least the top level thickness
-               zhisf_tbl(ji,jj) = MAX(rhisf_tbl_0(ji,jj), e3u_n(ji,jj,ikt))
+               zhisf_tbl(ji,jj) = MAX( rhisf_tbl_0(ji,jj) , e3u_n(ji,jj,ikt) )
 
                ! determine the deepest level influenced by the boundary layer
@@ -755,6 +748,7 @@
             END DO
          END DO
-         DO jj = 2,jpj
-            DO ji = 2,jpi
+         DO jj = 2, jpj
+            DO ji = 2, jpi
+!!gm a wet-point only average should be used here !!!
                pvarout(ji,jj) = 0.5_wp * (pvarout(ji,jj) + pvarout(ji-1,jj))
             END DO
@@ -786,6 +780,7 @@
             END DO
          END DO
-         DO jj = 2,jpj
-            DO ji = 2,jpi
+         DO jj = 2, jpj
+            DO ji = 2, jpi
+!!gm a wet-point only average should be used here !!!
                pvarout(ji,jj) = 0.5_wp * (pvarout(ji,jj) + pvarout(ji,jj-1))
             END DO
@@ -882,4 +877,5 @@
       !
    END SUBROUTINE sbc_isf_div
+
    !!======================================================================
 END MODULE sbcisf
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trd_oce.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trd_oce.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trd_oce.F90	(revision 8143)
@@ -72,5 +72,5 @@
    INTEGER, PUBLIC, PARAMETER ::   jpdyn_atf  = 10     !: Asselin time filter
    INTEGER, PUBLIC, PARAMETER ::   jpdyn_tau  = 11     !: surface stress
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_bfri = 12     !: implicit bottom friction (ln_bfrimp=.TRUE.)
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_bfri = 12     !: implicit bottom friction (ln_drgimp=.TRUE.)
    INTEGER, PUBLIC, PARAMETER ::   jpdyn_ken  = 13     !: use for calculation of KE
    !
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trddyn.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trddyn.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trddyn.F90	(revision 8143)
@@ -15,28 +15,28 @@
    USE oce            ! ocean dynamics and tracers variables
    USE dom_oce        ! ocean space and time domain variables
-   USE zdf_oce        ! ocean vertical physics variables
+   USE phycst         ! physical constants
+   USE sbc_oce        ! surface boundary condition: ocean
+   USE zdf_oce        ! ocean vertical physics: variables
+   USE zdfdrg         ! ocean vertical physics: bottom friction
    USE trd_oce        ! trends: ocean variables
-   USE zdfbfr         ! bottom friction
-   USE sbc_oce        ! surface boundary condition: ocean
-   USE phycst         ! physical constants
    USE trdken         ! trends: Kinetic ENergy 
    USE trdglo         ! trends: global domain averaged
    USE trdvor         ! trends: vertical averaged vorticity 
    USE trdmxl         ! trends: mixed layer averaged 
+   !
    USE in_out_manager ! I/O manager
    USE lbclnk         ! lateral boundary condition 
    USE iom            ! I/O manager library
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC trd_dyn        ! called by all dynXX modules
+   PUBLIC trd_dyn        ! called by all dynXXX modules
 
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -103,6 +103,6 @@
       INTEGER ::   ji, jj, jk   ! dummy loop indices
       INTEGER ::   ikbu, ikbv   ! local integers
-      REAL(wp), POINTER, DIMENSION(:,:)   ::   z2dx, z2dy   ! 2D workspace 
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   z3dx, z3dy   ! 3D workspace 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   z2dx, z2dy   ! 2D workspace 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   z3dx, z3dy   ! 3D workspace 
       !!----------------------------------------------------------------------
       !
@@ -118,5 +118,5 @@
       CASE( jpdyn_keg )   ;   CALL iom_put( "utrd_keg", putrd )    ! Kinetic Energy gradient (or had)
                               CALL iom_put( "vtrd_keg", pvtrd )
-                              CALL wrk_alloc( jpi, jpj, jpk, z3dx, z3dy )
+                              ALLOCATE( z3dx(jpi,jpj,jpk) , z3dy(jpi,jpj,jpk) )
                               z3dx(:,:,:) = 0._wp                  ! U.dxU & V.dyV (approximation)
                               z3dy(:,:,:) = 0._wp
@@ -133,25 +133,22 @@
                               CALL iom_put( "utrd_udx", z3dx  )
                               CALL iom_put( "vtrd_vdy", z3dy  )
-                              CALL wrk_dealloc( jpi, jpj, jpk, z3dx, z3dy )
-      CASE( jpdyn_zad )   ;   CALL iom_put( "utrd_zad", putrd )    ! vertical   advection
+                              DEALLOCATE( z3dx , z3dy )
+      CASE( jpdyn_zad )   ;   CALL iom_put( "utrd_zad", putrd )    ! vertical advection
                               CALL iom_put( "vtrd_zad", pvtrd )
-      CASE( jpdyn_ldf )   ;   CALL iom_put( "utrd_ldf", putrd )    ! lateral diffusion
+      CASE( jpdyn_ldf )   ;   CALL iom_put( "utrd_ldf", putrd )    ! lateral  diffusion
                               CALL iom_put( "vtrd_ldf", pvtrd )
       CASE( jpdyn_zdf )   ;   CALL iom_put( "utrd_zdf", putrd )    ! vertical diffusion 
                               CALL iom_put( "vtrd_zdf", pvtrd )
+                              !
                               !                                    ! wind stress trends
-                              CALL wrk_alloc( jpi, jpj, z2dx, z2dy )
+                              ALLOCATE( z2dx(jpi,jpj) , z2dy(jpi,jpj) )
                               z2dx(:,:) = ( utau_b(:,:) + utau(:,:) ) / ( e3u_n(:,:,1) * rau0 )
                               z2dy(:,:) = ( vtau_b(:,:) + vtau(:,:) ) / ( e3v_n(:,:,1) * rau0 )
                               CALL iom_put( "utrd_tau", z2dx )
                               CALL iom_put( "vtrd_tau", z2dy )
-                              CALL wrk_dealloc( jpi, jpj, z2dx, z2dy )
-      CASE( jpdyn_bfr )       ! called if ln_bfrimp=T
-                              CALL iom_put( "utrd_bfr", putrd )    ! bottom friction (explicit case)
-                              CALL iom_put( "vtrd_bfr", pvtrd )
-      CASE( jpdyn_atf )   ;   CALL iom_put( "utrd_atf", putrd )        ! asselin filter trends 
-                              CALL iom_put( "vtrd_atf", pvtrd )
-      CASE( jpdyn_bfri )  ;   IF( ln_bfrimp ) THEN                     ! bottom friction (implicit case)
-                              	CALL wrk_alloc( jpi, jpj, jpk, z3dx, z3dy )
+                              DEALLOCATE( z2dx , z2dy )
+                              !                                    ! bottom stress tends (implicit case)
+                              IF( ln_drgimp ) THEN
+                                 ALLOCATE( z3dx(jpi,jpj,jpk) , z3dy(jpi,jpj,jpk) )
                               	z3dx(:,:,:) = 0._wp   ;   z3dy(:,:,:) = 0._wp  ! after velocity known (now filed at this stage)
                               	DO jk = 1, jpkm1
@@ -160,14 +157,19 @@
                               	         ikbu = mbku(ji,jj)          ! deepest ocean u- & v-levels
                                           ikbv = mbkv(ji,jj)
-                                          z3dx(ji,jj,jk) = bfrua(ji,jj) * un(ji,jj,ikbu) / e3u_n(ji,jj,ikbu)
-                                          z3dy(ji,jj,jk) = bfrva(ji,jj) * vn(ji,jj,ikbv) / e3v_n(ji,jj,ikbv)
+                                          z3dx(ji,jj,jk) = 0.5*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) )*un(ji,jj,ikbu)/e3u_n(ji,jj,ikbu)
+                                          z3dy(ji,jj,jk) = 0.5*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) )*vn(ji,jj,ikbv)/e3v_n(ji,jj,ikbv)
                               	      END DO
                               	   END DO
                               	END DO
-                              	CALL lbc_lnk( z3dx, 'U', -1. ) ; CALL lbc_lnk( z3dy, 'V', -1. )
-                              	CALL iom_put( "utrd_bfri", z3dx )
-                              	CALL iom_put( "vtrd_bfri", z3dy )
-                              	CALL wrk_dealloc( jpi, jpj, jpk, z3dx, z3dy )
-         					      ENDIF
+                              	CALL lbc_lnk( z3dx, 'U', -1. )   ;   CALL lbc_lnk( z3dy, 'V', -1. )
+                              	CALL iom_put( "utrd_bfr", z3dx )
+                              	CALL iom_put( "vtrd_bfr", z3dy )
+                                 DEALLOCATE( z3dx , z3dy )
+                              ENDIF
+      CASE( jpdyn_bfr )       ! called if ln_drgimp=F
+                              CALL iom_put( "utrd_bfr", putrd )    ! bottom friction (explicit case)
+                              CALL iom_put( "vtrd_bfr", pvtrd )
+      CASE( jpdyn_atf )   ;   CALL iom_put( "utrd_atf", putrd )        ! asselin filter trends 
+                              CALL iom_put( "vtrd_atf", pvtrd )
       END SELECT
       !
